﻿; ------------------------------------------------------------------------------------
; Fast Hashtable Include
; angepasst für Simple Container
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Structures & Enumerations
; ------------------------------------------------------------------------------------

; EnableExplicit

Enumeration
  #InitialTableSize = 2503
EndEnumeration

Structure sHASHMAP
  Blocksize.i
  Mapsize.i
  count.i
  *_map.MapArray
EndStructure

Structure sElement
  *key
  used.b
  Value.i
EndStructure

Structure MapArray
  _Map.sElement[0]
EndStructure

; ------------------------------------------------------------------------------------
; Internal
; ------------------------------------------------------------------------------------

Macro _DoResize(_State, _Maximum)
  _State>(1*_Maximum/2)
EndMacro

Macro _ResizeTo(_current, _blocksize)
  _current + _blocksize
EndMacro

Macro _DoQuad()
  CompilerIf #True
    counter + 1
    hash + ((counter/2)*(counter/2))*(-1 + (r*2))
    hash%*hMap\Mapsize
    If hash<0 : hash + *hMap\Mapsize : EndIf
    r = r ! 1
  CompilerElse
    mapsize = *hMap\mapsize
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      Protected 
      
      !ADD qword[p.v_counter], 1 ; counter+1
      !MOV RAX,qword[p.v_counter]
      !MOV RBX,qword[p.v_mapsize]
      
      !MOV qword[p.v_test], RAX
      Debug TEST
      
      !SHR RAX, 1
      
      !MOV qword[p.v_test], RAX
      Debug TEST
     
      !IMUL RAX,RAX ; ((counter/2)*(counter/2))
      !MOV RSI,qword[p.v_r]
      !SHL RSI,1 ; r*2
      !SUB RSI,1 ; -1
      !IMUL RAX,RSI
      !ADD RAX,qword[p.v_hash] ; hash + rest
      !CDQ
      !IDIV RBX ;hash%*hMap\mapsize
      !MOV RAX, RDX
      ; If hash<0 : hash + *hMap\Mapsize : EndIf
      !AND RAX,RAX
      !JNG @f
      !ADD RDX,RBX
      !@@:
      !MOV qword[p.v_hash], RDX
      ; r ! 1
      !XOR qword[p.v_r], 1  
    CompilerElse
      ;Pseudo-Code 32-Bit
      mapsize = *hMap\mapsize
      !INC dword[p.v_counter]
    !MOV EAX,dword[p.v_counter]
    !MOV EBX, dword[p.v_mapsize]
    !MOV ECX,2
    !CDQ
    !SHL EAX,1        !;DIV ECX ; counter/2
    !IMUL EAX,EAX ; ((counter/2)*(counter/2))
    !MOV ESI, dword[p.v_r]
    !ADD ESI, ESI ; r*2
    !DEC ESI ; -1
    !IMUL EAX,ESI
    !ADD EAX, dword[p.v_hash] ; hash + rest
    !CDQ
    !DIV EBX ;hash%*hMap\mapsize
    ;  !MOV EAX, EDX       - Wert wird in EDX belassen, da unten mit EDX weitergerechnet wird, und nicht mit EAX
    ; If hash<0 : hash + *hMap\Mapsize : EndIf
     !AND EDX,EDX       ;!AND EAX,EAX     , Prüfung ob kleiner Null wird auf EDX geändert, da steht der Wert
    !JGE @f
    !ADD EDX,EBX
    !@@:
    !MOV dword[p.v_hash], EDX
    ; r ! 1
    !XOR dword[p.v_r], 1
;       !ADD dword[p.v_counter], 1 ; counterü1
;       !MOV EAX,dword[p.v_counter]
;       !MOV EBX,dword[p.v_mapsize]
;       !SHR EAX,1
;       
;       !IMUL EAX,EAX ; ((counter/2)*(counter/2))
;       !MOV ESI,dword[p.v_r]
;       !SHL ESI,1 ; r*2
;       !SUB ESI,1 ; -1
;       !IMUL EAX,ESI
;       !ADD EAX,dword[p.v_hash] ; hash + rest
;       !CDQ
;       !IDIV EBX ;hash%*hMap\mapsize
;       !MOV EAX,EDX
;       ; If hash<0 : hash + *hMap\Mapsize : EndIf
;       !AND EAX,EAX
;       !JGE @f
;       !ADD EDX,EBX
;       !@@:
;       !MOV dword[p.v_hash], EDX
;       ; r ! 1
;       !XOR dword[p.v_r], 1
    CompilerEndIf
    Debug hash
  CompilerEndIf
EndMacro

Procedure _CreateHash(*pKey.CHARACTER, Mapsize.i)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    !MOV EAX,5381            ;Startwert hash
    !MOV EBX,EAX             ;für erste Addition in Schleife
    !MOV ESI,dword[p.p_pKey] ;oder LEA ESI,[v_pKey], aber wenn p_pKey eh schon da ist...
    !XOR EDX,EDX             ;EDX auf Null setzen
    !MOV CL,5                ;sollte so schneller sein
    !@@:
    !MOV DL,[ESI]            ;also kein Unicode!
    !OR DL,DL                ;Test auf Null
    !JZ @f                   ;ist Null, Sprung vorwärts
    !SHL EAX,CL              
    !ADD EAX,EBX
    !ADD EAX,EDX
    !MOV EBX,EAX             ;"alten" hash sichern
    !INC ESI
    !JMP @b                  ;Sprung rückwärts, nächsten Wert einlesen
    !@@:
    !MOV dword[p.p_pKey],esi ;wirklich Pointer erhöhen? Sonst weg
    !XOR EDX,EDX             ;schneller und richtiger (!) als CDQ ich gehe hier mal von vorzeichenlosen Werten aus
    !DIV dword[p.v_Mapsize]  ;EAX ist noch hash
    !MOV EAX,EDX             ;Divisions-Rest
  CompilerElse
    !MOV RAX,5381            ;Startwert hash
    !MOV RBX,RAX             ;für erste Addition in Schleife
    !MOV ESI,dword[p.p_pKey] ;oder LEA ESI,[v_pKey], aber wenn p_pKey eh schon da ist...
    !XOR RDX,RDX             ;EDX auf Null setzen
    !MOV CL,5                ;sollte so schneller sein
    !@@:
    !MOV DL,[ESI]            ;also kein Unicode!
    !OR DL,DL                ;Test auf Null
    !JZ @f                   ;ist Null, Sprung vorwärts
    !SHL RAX,CL              ;SHL = SAL; SAL wird selten angegeben
    !ADD RAX,RBX
    !ADD RAX,RDX
    !MOV RBX,RAX             ;"alten" hash sichern
    !INC ESI
    !JMP @b                  ;Sprung rückwärts, nächsten Wert einlesen
    !@@:
    !MOV dword[p.p_pKey],esi ;wirklich Pointer erhöhen? Sonst weg
    !XOR RDX,RDX             ;schneller und richtiger (!) als CDQ ich gehe hier mal von vorzeichenlosen Werten aus
    !DIV dword[p.v_Mapsize]  ;EAX ist noch hash
    !MOV RAX,RDX             ;Divisions-Rest
  CompilerEndIf
  ProcedureReturn        ;Gibt Hash in EAX zurück
EndProcedure

Procedure _NextPrime(num.i)
  Protected prime.i, i.i, start.i
  If Int(num/2)*2<>num ; nur Ungerade Zahlen prüfen
    num + 1
  EndIf
  Repeat
    i = 2
    While i*i<num
      If num%i = 0
        prime = #False
        Break
      Else
        prime = #True
      EndIf
      If i> = 3 ; Ab 3 in 3erschritten prüfen
        i + 3
      Else
        i + 2
      EndIf
    Wend
    If prime = #False
      num + 1
      If num%10 = 5 ; Zahlen die mit 5 enden fliegen raus
        num + 1
      EndIf
    Else
      Break
    EndIf
  ForEver
  ProcedureReturn num
EndProcedure

Procedure _ReDimHashmap(*hMap.sHASHMAP)
  Protected NewSize.i = _NextPrime(_ResizeTo(*hMap\Mapsize, *hMap\Blocksize))
  Protected *pNewMap.MapArray = AllocateMemory(NewSize*SizeOf(sElement))
  Protected *p.MapArray = *hMap\_map, i.i, counter.i, r.i, hash.i
  For i = 0 To *hMap\Mapsize-1
    If *p\_map[i]\used = #True
      hash = _CreateHash(@*p\_map[i]\key, NewSize)
      counter = 0 : r = 0
      While counter<NewSize
        If *pNewMap\_map[hash]\used = #False
          CopyMemory(*p\_map[i], *pNewMap\_map[hash], SizeOf(sElement))
          Break
        Else
          counter + 1
          hash + ((counter/2)*(counter/2))*(-1 + (r*2))
          hash%NewSize
          If hash<0 : hash + NewSize : EndIf
          r ! 1
        EndIf
      Wend
    EndIf
  Next i
  FreeMemory(*hMap\_map)
  *hMap\_map = *pNewMap
  *hMap\Mapsize = NewSize
EndProcedure

; ------------------------------------------------------------------------------------
; Public
; ------------------------------------------------------------------------------------

Procedure HT_SetValue(*hMap.sHASHMAP, key.s, Value.i)
  Protected counter, r, mapsize
  Protected *p.MapArray, hash, *e.sElement
  hash = _CreateHash(@key, *hMap\Mapsize)
  *p = *hMap\_map
  While counter<*hMap\Mapsize And Not *hMap\count = *hMap\Mapsize
    *e = *p\_map[hash] ; schneller da der Index nur 1* berechnet werden muss
    With *e
      If \used = #False Or (\key And (CompareMemoryString(\key, @key) = #PB_String_Equal))
        
        If Not \key
          \key = AllocateMemory(StringByteLength(key)+SizeOf(Character))
          PokeS(\key, key)
          \used = #True
          *hMap\count + 1
        EndIf
        
        \Value = Value
        
        If _DoResize(*hMap\count, *hMap\Mapsize)
          _ReDimHashmap(*hMap)
        EndIf
        ProcedureReturn #True
      Else
        _DoQuad()
      EndIf
    EndWith
  Wend
EndProcedure

Procedure HT_GetValue(*hMap.sHASHMAP, key.s)
  Protected counter, r, mapsize
  Protected *p.MapArray, hash, *e.sElement
  hash = _CreateHash(@key, *hMap\Mapsize)
  *p = *hMap\_map
  While counter<*hMap\Mapsize
    *e = *p\_map[hash] ; schneller da der Index nur 1* berechnet werden muss
    With *e
      If Not \used
        ProcedureReturn #False
      ElseIf (CompareMemoryString(\key, @key) = #PB_String_Equal)
        ProcedureReturn \Value
      Else ; // quadratic probe
        _DoQuad()
      EndIf
    EndWith
  Wend
EndProcedure

Procedure HT_Free(*hMap.sHASHMAP)
  Protected i
  For i = 0 To *hMap\Mapsize-1
    If *hMap\_map\_map[i]\key
      FreeMemory(*hMap\_map\_map[i]\key)  
    EndIf
  Next
  FreeMemory(*hMap\_map)
  ProcedureReturn #True
EndProcedure

Procedure HT_New(BlockSize = #InitialTableSize)
  Protected *hMap.sHASHMAP, i.i, prime.i
  BlockSize = _NextPrime(BlockSize)
  *hMap = AllocateMemory(SizeOf(sHASHMAP))
  If *hMap
    *hMap\BlockSize = Blocksize
    *hMap\Mapsize = Blocksize
    *hMap\_map = AllocateMemory(Blocksize*SizeOf(sElement))
    ProcedureReturn *hMap
  EndIf
EndProcedure
; IDE Options = PureBasic 4.50 (Windows - x64)
; CursorPosition = 43
; FirstLine = 35
; Folding = --
; EnableAsm
; EnableXP
; Executable = C:\Dokumente und Einstellungen\Alex\Desktop\test.exe
; CPU = 1
; EnableCompileCount = 76
; EnableBuildCount = 1
; EnableExeConstant