; ------------------------------------------------------------------------------------
; Intelligentes Array
; Author: Alexander Aigner
; PB 4.3+ x86/x64
;
;
; ------------------------------------------------------------------------------------

; Ebenen - Gre
#LevelSize = 10

Structure SArray_Data ; Daten Element
  *Next.SArray ; Tiefere Ebene
  Value.i ; Eintrag
EndStructure

Structure SArray_Holder ; Array Holder
  Entry.SArray_Data[#LevelSize]
EndStructure

Structure SArray ; Array Main - Struktur
  SArray.SArray_Holder
EndStructure

Macro SArray_New() ; Neues Array anlegen
  AllocateMemory(SizeOf(SArray))
EndMacro

Procedure SArray_Set(*SArray.SArray, Index.i, Value.i) ; Eintrag setzen
  Protected *SArrayEntry.SArray_Data, *cur.SArray_Holder = *SArray
  Repeat
    ; Aktuelles Element
    *SArrayEntry = @*cur\Entry[Index%#LevelSize]
    Index/#LevelSize
    If Index ; Weiter in die Tiefe
      If Not *SArrayEntry\Next ; Noch nicht angelegt?
        *SArrayEntry\Next = SArray_New()
      EndIf
      ; eine Ebene tiefer gehen
      *cur = *SArrayEntry\Next\SArray
    EndIf
  Until Not Index
  ; Eintrag schreiben
  *SArrayEntry\Value = Value
EndProcedure

Procedure SArray_Get(*SArray.SArray, Index.i)
  Protected *SArrayEntry.SArray_Data, *cur.SArray_Holder = *SArray
  Repeat
    *SArrayEntry = @*cur\Entry[Index%#LevelSize]
    Index/#LevelSize
    If Index
      If Not *SArrayEntry\Next
        ; Eintrag gibts noch nicht
        ProcedureReturn #False
      EndIf
      *cur = *SArrayEntry\Next\SArray
    EndIf
  Until Not Index
  ; Wert lesen
  ProcedureReturn *SArrayEntry\Value
EndProcedure

; Freigabe Procedure ist hoch-rekursiv, kann etwas lnger dauern...
Procedure _SArray_FreeSub(*IData.SArray_Holder)
  Protected i
  For i = 0 To #LevelSize-1
    If *IData\Entry[i]\Next
      _SArray_FreeSub(@*IData\Entry[i]\Next\SArray)
    EndIf
  Next
  FreeMemory(*IData)
EndProcedure

; Array freigeben
Macro SArray_Free(SArray)
  _SArray_FreeSub(SArray)
EndMacro
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 46
; FirstLine = 38
; Folding = -
; EnableXP
; DisableDebugger