XIncludeFile "SC.pbi"

DisableExplicit

Procedure SCF_PackFile(SC, Id$, File$, CompressionLevel = 7)
  Protected File, *Mem, MemSize
  File = ReadFile(#PB_Any, File$)
  If File
    
    ; Datei ganz normal einlesen
    MemSize = Lof(File)
    *Mem = AllocateMemory(MemSize)
    ReadData(File, *Mem, MemSize)
    CloseFile(File)  
    
    ; Datei in SC - Container speichern
    SC_AddEntry(SC, Id$, *Mem, MemSize)
    FreeMemory(*Mem)
    
    ; Datei - Infos dazuspeichern
    SC_SetXtraDataQuad(SC, "Attributes", GetFileAttributes(File$))
    SC_SetXtraDataQuad(SC, "DateCreated", GetFileDate(File$, #PB_Date_Created))
    SC_SetXtraDataQuad(SC, "DateAccessed", GetFileDate(File$, #PB_Date_Accessed))
    SC_SetXtraDataQuad(SC, "DateModified", GetFileDate(File$, #PB_Date_Modified))
    SC_SetXtraDataString(SC, "OriginalName", GetFilePart(File$))
    
  EndIf
  
EndProcedure

Procedure SCF_UnPackFile(SC, Id$, Folder$)
  Protected File$, File
  
  SC_GetEntry(SC, "keks")
  If SC_GetEntry(SC, Id$)
    
    File$ = Folder$ + SC_GetXtraDataString(SC, "OriginalName")
    File = CreateFile(#PB_Any, File$)
    If File
      WriteData(File, SC_GetMem(SC), SC_GetMemSize(SC))
      CloseFile(File)
      
      ; Datei - Infos dazuspeichern
      SetFileAttributes(File$, SC_GetXtraDataQuad(SC, "Attributes"))
      SetFileDate(File$, SC_GetXtraDataQuad(SC, "DateCreated"), #PB_Date_Created)
      SetFileDate(File$, SC_GetXtraDataQuad(SC, "DateAccessed"), #PB_Date_Accessed)
      SetFileDate(File$, SC_GetXtraDataQuad(SC, "DateModified"), #PB_Date_Modified)
      
    EndIf
    
  EndIf
  
EndProcedure

Procedure SC_SaveList(SC, Id$, List myList(), ElementSize)
  Protected *cListMem, *ListMem, ListSize = ListSize(myList())
  Protected RtVar
  
  If ListSize
    ; Listenspeicher anlegen
    *ListMem = AllocateMemory(ListSize*ElementSize)
    *cListMem = *ListMem
    
    ResetList(myList()) ; Liste in Speicher umlegen
    While NextElement(myList())
      CopyMemory(@myList(), *cListMem, ElementSize)
      *cListMem + ElementSize
    Wend
    
    If SC_AddEntry(SC, Id$, *ListMem, ListSize*ElementSize) ; in den Container speichern
      ; zustzliche Daten schreiben, zur vereinfachung
      SC_SetXtraDataQuad(SC, "ElementSize", ElementSize)
      SC_SetXtraDataQuad(SC, "ListSize", ListSize)
      
      ; Rckgabe wahrsetzen
      RtVar = #True
    EndIf
    
    FreeMemory(*ListMem)
    
  EndIf
  
  ProcedureReturn RtVar
EndProcedure

Procedure SC_LoadList(SC, Id$, List myList())
  Protected *cListMem, ListSize, ElementSize
  Protected RtVar
  
  If SC_GetEntry(SC, Id$) ; ist der Eintrag da?
    *cListMem = SC_GetMem(SC)
    
    ; Extradaten laden
    ListSize = SC_GetXtraDataQuad(SC, "ListSize")
    ElementSize = SC_GetXtraDataQuad(SC, "ElementSize")
    
    If SC_GetMemSize(SC) = ListSize*ElementSize ; sicherheitsprfung
      ClearList(myList())
      
      While ListSize ; Speicher in Liste bertragen
        AddElement(myList())
        CopyMemory(*cListMem, @myList(), ElementSize)
        
        *cListMem + ElementSize
        ListSize-1  
      Wend
      
      RtVar = #True
    EndIf
    
  EndIf
  
  ProcedureReturn RtVar
EndProcedure

; f = SC_Open("F:\test.sc")
; 
; ;Debug f
; SCF_PackFile(f, "test", "F:\test.dll")
; ;SC_DeleteEntry(f, "test")
; ;SCF_PackFile(f, "test", "F:\test.dll")
; 
; 
; 
; SCF_UnPackFile(f, "test", "F:\test2.dll")
; SCF_UnPackFile(f, "test", "F:\test3.dll")
; SCF_UnPackFile(f, "test", "F:\test4.dll")
; SCF_UnPackFile(f, "test", "F:\test5.dll")
; 
; SC_Close(f)


; Define SC
; Define Test.s
; 
; ; ffnen / Erstellen
; SC = SC_Open("F:\testcontainer.sc")
; 
; If SC
;   ; Wert schreiben
;   Test.s="Usambaraveilchen"
;   SC_AddEntry(SC, "huhu", @Test, Len(Test))
;   SC_Close(SC)
; EndIf
; 
; ; ffnen
; SC = SC_Open("F:\testcontainer.sc")
; If SC
;   ; Wert auslesen
;   If SC_GetEntry(SC, "huhu")
;     Debug PeekS(SC_GetMem(SC), SC_GetMemSize(SC))
;   EndIf     
;   SC_Close(SC)
; EndIf


EnableExplicit

Structure sTelefon
  Nummer.s
  Typ.s
EndStructure

Structure sPerson
  Vorname.s
  Nachname.s
  List Telefon.sTelefon()
EndStructure

NewList Person.sPerson()

Procedure AddPerson(List Person.sPerson(), Vorname.s, Nachname.s, TelefonTyp1.s, TelefonNummer1.s, TelefonTyp2.s, TelefonNummer2.s)
  AddElement(Person())
  Person()\Vorname  = Vorname
  Person()\Nachname = Nachname
  AddElement(Person()\Telefon())
  Person()\Telefon()\Typ    = TelefonTyp1
  Person()\Telefon()\Nummer = TelefonNummer1
  AddElement(Person()\Telefon())
  Person()\Telefon()\Typ    = TelefonTyp2
  Person()\Telefon()\Nummer = TelefonNummer2
EndProcedure


Macro _AddStringToMem(_Mem, _String, _SizeCounter)
  _Mem = ReAllocateMemory(_Mem, _SizeCounter + StringByteLength(_String) + SizeOf(Character) + SizeOf(Long))
  PokeL(_Mem + _SizeCounter, StringByteLength(_String) + SizeOf(Character))
  PokeS(_Mem + _SizeCounter + SizeOf(Long), _String)
  _SizeCounter + StringByteLength(_String) + SizeOf(Character) + SizeOf(Long)
EndMacro

Macro _AddLongToMem(_Mem, _Long, _SizeCounter)
  _Mem = ReAllocateMemory(_Mem, _SizeCounter + SizeOf(Long))
  PokeL(_Mem + _SizeCounter, _Long)
  _SizeCounter + SizeOf(Long)
EndMacro

Macro _GetStringFromMem(_Mem, _String, _SizeCounter)
  _String = PeekS(_Mem + _SizeCounter + SizeOf(Long), PeekL(_Mem + _SizeCounter))
  _SizeCounter + SizeOf(Long) + PeekL(_Mem + _SizeCounter)
EndMacro

Macro _GetLongFromMem(_Mem, _Long, _SizeCounter)
  _Long = PeekL(_Mem + _SizeCounter)
  _SizeCounter + SizeOf(Long)
EndMacro

Procedure SC_SavePersonen(SC, Id$, List Person.sPerson())
  Protected *SaveMem, MemSize,  ListCount, MainCount = ListSize(Person())
  
  *SaveMem = AllocateMemory(SizeOf(Long))
  PokeL(*SaveMem, MainCount)
  MemSize = SizeOf(Long)
  
  ForEach Person()
    
    ListCount = ListSize(Person()\Telefon())
    _AddStringToMem(*SaveMem, Person()\Vorname, MemSize)
    _AddStringToMem(*SaveMem, Person()\Nachname, MemSize)
    _AddLongToMem(*SaveMem, ListCount, MemSize)
    
    ForEach Person()\Telefon()
      _AddStringToMem(*SaveMem, Person()\Telefon()\Nummer, MemSize)  
      _AddStringToMem(*SaveMem, Person()\Telefon()\Typ, MemSize)  
    Next
    
  Next
  
  SC_AddEntry(SC, Id$, *SaveMem, MemSize)
  
EndProcedure

Procedure SC_LoadPersonen(SC, Id$, List Person.sPerson())
  Protected i, ii, *SaveMem, MemSize, ListCount, MainCount
  
  If SC_GetEntry(SC, Id$)
    
    *SaveMem = SC_GetMem(SC)
    MainCount = PeekL(*SaveMem)
    MemSize = SizeOf(Long)
    
    
    For i = 1 To MainCount
      AddElement(Person())
      _GetStringFromMem(*SaveMem, Person()\Vorname, MemSize)
      _GetStringFromMem(*SaveMem, Person()\Nachname, MemSize)
      _GetLongFromMem(*SaveMem, ListCount, MemSize)
      
      For ii = 1 To ListCount
        AddElement(Person()\Telefon())
        _GetStringFromMem(*SaveMem, Person()\Telefon()\Nummer, MemSize)
        _GetStringFromMem(*SaveMem, Person()\Telefon()\Typ, MemSize)
        
      Next  
      
    Next
    
  EndIf
  
EndProcedure


; ################
; # Erstellen und speichern
; ################

Define SC = SC_Open("F:\testcontainer.sc", "")  ; Pfad anpassen

#Try_Transaction = #True
If SC
  Define t = ElapsedMilliseconds()
  Define i
  If #Try_Transaction
    SC_Transaction(SC)
  EndIf
  For i = 1 To 500
    AddPerson(Person(), "Clark", "Kent",   "Festnetz", "1111", "Mobil", "2222")
    AddPerson(Person(), "Bruce", "Wayne",  "Festnetz", "3333", "Mobil", "4444")
    AddPerson(Person(), "Peter", "Parker", "Festnetz", "5555", "Mobil", "6666")
  
    SC_SavePersonen(SC, "test"+Str(i), Person())
  Next
  If #Try_Transaction
    SC_Commit(SC)
  EndIf
  Define t2 = ElapsedMilliseconds()-t
  SC_Close(SC)
  Define t1 = ElapsedMilliseconds()-t
  MessageRequester("", Str(t1) + Chr(13) + Str(t2))
EndIf

End

; ################
; # Laden und anzeigen
; ################

SC = SC_Open("F:\testcontainer.sc", "lala")  ; Pfad anpassen!

If SC
 
  ClearList(Person())
 
  SC_LoadPersonen(SC, "test100", Person())
 
  ForEach Person()
    Debug "Name: " + Person()\Vorname + " " + Person()\Nachname
    ForEach Person()\Telefon()
      Debug "Telefon: " + Person()\Telefon()\Nummer + " (" + Person()\Telefon()\Typ + ")"
    Next
    Debug "-----------------"
  Next
 
  SC_Close(SC)
 
EndIf


; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 278
; FirstLine = 278
; Folding = --
; EnableXP